#include "EleeBot.h"

Engine engine;
IRC irc;
Sensor sensor;
LineTracker lineTracker;

EleeBot::EleeBot() {
}

EleeBot::~EleeBot() {
  
}

Engine EleeBot::getEngine() {
  return engine;
}

IRC EleeBot::getIRC() {
  return irc;
}

Sensor EleeBot::getSensor() {
  return sensor;
}

LineTracker EleeBot::getLineTracker() {
  return lineTracker;
}

void EleeBot::setup() {
  Serial.begin(9600); //Open the serial port and set the baud rate to 9600

  irc.setup();
  engine.setup();
  sensor.setup();
}

void EleeBot::moveForward(int speed, int time){  
  moveForward(speed);
  wait(time);
  stopRobot();
  
  Serial.println("Forward");
}

void EleeBot::moveForward(int speed){
  engine.turnRightEngineForward(speed);
  engine.turnLeftEngineForward(speed);
  
  Serial.println("Forward");
}

void EleeBot::moveBackward(int speed, int time) {
  moveBackward(speed);
  wait(time);
  stopRobot();
  
  Serial.println("Back");  
}

void EleeBot::moveBackward(int speed) {
  engine.turnRightEngineBackward(speed);
  engine.turnLeftEngineBackward(speed);
  
  Serial.println("Back");  
}

void EleeBot::turnRight(int speed, int time) {
  turnRight(speed);
  wait(time);
  engine.stopLeftEngine();
}

void EleeBot::turnRight(int speed) {
  engine.stopRightEngine();
  engine.turnLeftEngineForward(speed);
}

void EleeBot::turnLeft(int speed, int time) {
  turnLeft(speed);
  wait(time);
  engine.stopRightEngine();
}

void EleeBot::turnLeft(int speed) {
  engine.stopLeftEngine();
  engine.turnRightEngineForward(speed);
}

void EleeBot::spinLeft(int speed, int time) {
  engine.turnRightEngineForward(speed);
  engine.turnLeftEngineBackward(speed);
  wait(time);
  stopRobot();
}

void EleeBot::spinRight(int speed, int time) {
  engine.turnLeftEngineForward(speed);
  engine.turnRightEngineBackward(speed);
  wait(time);
  stopRobot();
}

void EleeBot::spinLeft(int speed) {
  engine.turnRightEngineForward(speed);
  engine.turnLeftEngineBackward(speed);
}

void EleeBot::spinRight(int speed) {
  engine.turnLeftEngineForward(speed);
  engine.turnRightEngineBackward(speed);
}

void EleeBot::wait(int sec) {
  delay(sec * 10);
}

void EleeBot::stopRobot() {
  engine.stopRightEngine();
  engine.stopLeftEngine();
}

