#include "Engine.h"

//#define DIGITAL_ENGINE
#define ANALOG_ENGINE

/*define logic control output pin*/
int in1=6;
int in2=7;
int in3=8;
int in4=9;
/*define channel enable output pins*/
int ENA=5;
int ENB=11;

int getSpeed(int speedRatio) {
  if (speedRatio > 100) {
    speedRatio = 100;
  }
  else if (speedRatio < 0) {
    speedRatio = 0;
  }
  
  int speed = speedRatio * 255 / 100;

  return speed;
}

Engine::Engine() {
  
}

Engine::~Engine() {
  
}

void Engine::setup() {
  /*Set the defined pins to the output*/
  
  pinMode(in1,OUTPUT);
  pinMode(in2,OUTPUT);
  pinMode(in3,OUTPUT);
  pinMode(in4,OUTPUT);
  pinMode(ENA,OUTPUT);
  pinMode(ENB,OUTPUT);
}

void Engine::_forward(int speed){
  analogWrite(ENA, getSpeed(speed));
  analogWrite(ENB, getSpeed(speed));
  digitalWrite(in1, HIGH);
  digitalWrite(in2, LOW);
  digitalWrite(in3, LOW);
  digitalWrite(in4, HIGH);
  Serial.println("go forward!");
}

void Engine::turnRightEngineBackward(int speed) {
  //Left wheels forward
  #ifdef DIGITAL_ENGINE
  digitalWrite(ENA,HIGH);
  #else
  analogWrite(ENA, getSpeed(speed));
  #endif
  digitalWrite(in1,LOW);
  digitalWrite(in2,HIGH);
}

void Engine::turnLeftEngineBackward(int speed) {
  #ifdef DIGITAL_ENGINE
  digitalWrite(ENB,HIGH);
  #else
  analogWrite(ENB, getSpeed(speed));
  #endif
  digitalWrite(in3,HIGH);
  digitalWrite(in4,LOW);
}

void Engine::turnRightEngineForward(int speed) {
  #ifdef DIGITAL_ENGINE
  digitalWrite(ENA, HIGH);
  #else
  analogWrite(ENA, getSpeed(speed));
  #endif
  //Left wheels back
  digitalWrite(in1,HIGH);
  digitalWrite(in2,LOW);
}

void Engine::turnLeftEngineForward(int speed) {
  #ifdef DIGITAL_ENGINE
  digitalWrite(ENB, HIGH);
  #else
  analogWrite(ENB, getSpeed(speed));
  #endif
  //Right wheels back
  digitalWrite(in3,LOW);
  digitalWrite(in4,HIGH);
}

void Engine::stopRightEngine() {
  digitalWrite(ENA,LOW);
}

void Engine::stopLeftEngine() {
  digitalWrite(ENB,LOW);
}



