#include "IRC.h"

#define IRC_F 16736925
#define IRC_B 16754775
#define IRC_L 16720605
#define IRC_R 16761405
#define IRC_S 16712445
#define IRC_UNKNOWN_F 5316027
#define IRC_UNKNOWN_B 2747854299
#define IRC_UNKNOWN_L 1386468383
#define IRC_UNKNOWN_R 553536955
#define IRC_UNKNOWN_S 3622325019

int RECV_PIN = 12;

IRrecv irrecv(RECV_PIN);
decode_results results;
unsigned long val;

IRC::IRC() {
  
}

IRC::~IRC() {
  
}

void IRC::setup() {
  irrecv.enableIRIn();
}

int IRC::getIRCKey() {
  int key = 0;
  if (irrecv.decode(&results)){ 
    val = results.value;
    Serial.println(val);
    irrecv.resume();
    switch(val){
    case IRC_F: 
    case IRC_UNKNOWN_F:
      key = IRC_FW;
      break;
    case IRC_B: 
    case IRC_UNKNOWN_B:
      key = IRC_BCK;
      break;
    case IRC_L: 
    case IRC_UNKNOWN_L:
      key = IRC_LEFT;
      break;
    case IRC_R: 
    case IRC_UNKNOWN_R:
      key = IRC_RIGHT;
      break;
    case IRC_S: 
    case IRC_UNKNOWN_S:
      key = IRC_STOP;
      break;
    }
  }

  return key; 
}

void IRC::waitKeyPressed() {
  while (!irrecv.decode(&results)){
    delay(100);
  }
  irrecv.resume();
}

boolean IRC::ifKeyPressed() {
  if (irrecv.decode(&results)){
    val = results.value;
    irrecv.resume();
    switch(val){
    case IRC_F: 
    case IRC_UNKNOWN_F:
    case IRC_B: 
    case IRC_UNKNOWN_B:
    case IRC_L: 
    case IRC_UNKNOWN_L:
    case IRC_R: 
    case IRC_UNKNOWN_R:
    case IRC_S: 
    case IRC_UNKNOWN_S:
      return true;
    default:
      return false;
      break;
    }
  }
}

